// RegistryManip.h: interface for the CRegistryManip class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REGISTRYMANIP_H__8A22C47A_5A40_4FA1_A47A_0A1DB3861D99__INCLUDED_)
#define AFX_REGISTRYMANIP_H__8A22C47A_5A40_4FA1_A47A_0A1DB3861D99__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/////////////////////////////////////////////////////////////////
//

const CString c_strStringIdReg		(_T("StringID"));
const CString c_strFlagReg			(_T("Flag"));
const CString c_strSepReg			(_T(";"));


/////////////////////////////////////////////////////////////////



class CRegistryManip  
{
public:

	CRegistryManip();
	virtual ~CRegistryManip();

///////////////

	// call RegOpenKeyEx, RegQueryValueEx, RegCloseKey
	BOOL getInfoFromRegistry(const HKEY hKey, const TCHAR* pSubKey, 
		 					 const TCHAR* pRegKey, TCHAR *pRes, 
							 DWORD dwType = REG_SZ);


	// Subkeys in der registry finden: RegEnumValue, RegQueryMultipleValues
	void FindAllParamsWithValues(HKEY hKeyBase, const CString& csKeyPath, 
								 CStringArray& acsKeyList, CStringArray& acsValList);

	// call RegCreateKeyEx
	BOOL CreateNewKey(const HKEY hKeyBase, const TCHAR* pKeyPath, const TCHAR* pNewKey);

	// call RegSetValueEx
	BOOL InputNewValue(const HKEY hKeyBase, const TCHAR* pKeyPath, const TCHAR* pKeyName, 
					   int nVal, BOOL& bIsInReg, DWORD dwType = REG_SZ);

	// ndern den Wert eines Parameters
	BOOL ChangeOneVal(const HKEY hKey, const TCHAR* pSubKey, const TCHAR* pRegKeyMain, 
					  const TCHAR* pRegKeyToChange, int nValMain, int nValPaar, 
					  BOOL& bWasFound);

	// holt alle Namen von Unterverzeichnissen
	BOOL GetNamesOfAllSubKeys(HKEY hKeyBase, const CString& csKeyPath, CStringArray& acsKeyList);

	// lschen ein Key oder ein Parameter
	BOOL DeleteInfoFromRegistry(const HKEY hKey, const char* pSubKey, const TCHAR* pKeyName);

	void ParseKeysAndValuesStr(const CStringArray& acsKeyList, const CStringArray& acsValList,
							   CStringArray& acsStringIdVal, CStringArray& acsFlagVal,
							   const CString& cstrName1, const CString& cstrName2);

	BOOL GetCountOfSubKeysAll(const HKEY hKey, const TCHAR* pSubKey, unsigned long& nSubKeysCount);


private:

	// call RegOpenKeyEx
	BOOL OpenRegKey(const HKEY hKey, const TCHAR* pSubKey, HKEY& hKeyPrograms, 
					REGSAM samDesired = KEY_READ);

	// call RegCloseKey
	BOOL CloseRegKey(HKEY hKey);

	// call RegQueryValueEx
	BOOL GetOneValueFromReg(HKEY hKey, const TCHAR* pRegKey, TCHAR *pRes, 
							DWORD dwType = REG_SZ);

	// call RegSetValueEx
	BOOL SetOneValue(HKEY hKey, const TCHAR* pKeyName, const TCHAR* pKeyVal, 
					 DWORD dwType = REG_SZ);

	// call RegQueryInfoKey
	BOOL GetCountOfSubKeys(HKEY hKey, unsigned long& nSubKeysCount);

	// call RegEnumKey: 
	// WICHTIG !!! Funktioniert nur fr den Fall, wenn man Unterverzeichnisse hat - 
	// dann kann man alle Namen von diesen Unterverzeichnissen rauslesen.
	// Wenn man sich im Verzeichnis befindet, wo nur Parameterliste mit Werten liegt, 
	// kann man diese Parameterliste nicht rauslesen. Dafuer muss man RegEnumValue benutzen
	BOOL GetNameOfCurSubKey(HKEY hKey, int nIndex, TCHAR *pNameRes);

	void ParseOneStr(CStringArray& acsStringVal, const CString& cstrVal, 
					 const CString& cstrKeyName, BOOL bStandSep = TRUE, 
					 TCHAR* pStrCurSep = NULL);

	BOOL SeekCurStringInReg(const CString& cstrBaseVal, const CString& cstrCurVal, 
							const CString& cstrKeyName);

	// prfen, ob dieses Verzeichnis in registry zu finden ist
	BOOL CheckIfKeyExists(const HKEY hKey, const TCHAR* pSubKey);

	// lschen ein SubKey 
	BOOL DeleteSubKeyFromRegistry(const HKEY hKey, const char* pSubKey);

	// lschen ein Parameter
	BOOL DeleteParamFromRegistry(const HKEY hKey, const char* pSubKey, const TCHAR* pKeyName);


///////

private:

	TCHAR	m_cstrValSep[10];
};

#endif // !defined(AFX_REGISTRYMANIP_H__8A22C47A_5A40_4FA1_A47A_0A1DB3861D99__INCLUDED_)
